{
    volScalarField& he = thermo->he();

    fvScalarMatrix EEqn
    (
        fvm::ddt(alpha, rho, he) + fvm::div(alphaPhi, he)
      + fvc::ddt(alpha, rho, K) + fvc::div(alphaPhi, K)
      + (
            he.name() == "e"
          ? fvc::ddt(alpha)*p + fvc::div(alphaPhi, p)
          /*fvc::div
            (
                fvc::absolute(alphaPhi/fvc::interpolate(rho), U),
                p,
                "div(phiv,p)"
            )*/
          : -alpha*dpdt
        )
      //- fvm::laplacian(turbulence->alphaEff(), he)
        -fvm::laplacian
        (
            fvc::interpolate(alpha)
            //*fvc::interpolate(thermo.alphaEff(turbulence()->mut())),
            *fvc::interpolate(turbulence->alphaEff()),
            he
        )
     ==
        //combustion->Sh()
        kinematicCloud.Sh(he)
      //+ limestoneParcels.Sh(he)
      + radiation->Sh(thermo())
      + fvOptions(alpha, rho, he)
    );

    EEqn.relax();

    fvOptions.constrain(EEqn);

    EEqn.solve();

    fvOptions.correct(he);

    thermo->correct();   //update thermophysicalModel
    radiation->correct();

    Info<< "T gas min/max   = " << min(T).value() << ", "
        << max(T).value() << endl;
}
